Subject: Bug: Unable to use an inferior package as a kernel in the system configuration
From: <[email-masked]>
To: "bug-guix" <[email-masked]>
Date: Wed, 12 Dec 2018 17:33:35 +0000 (GMT)
List-Id: <debbugs-submit.debbugs.gnu.org>

When putting an inferior package in the 'kernel' field of the system configuration, Guix fails with

```
gnu/system.scm:909:35: In procedure kernel->boot-label:
In procedure package-name: Wrong type argument: #<inferior-package [email-masked] 4182150>
```

The issue is very simple: The function that creates the text for a boot entry (`kernel->boot-label`) gets the name and version of the kernel using the functions `package-name` and `package-version`, which are incompatible with inferior packages.
The `(guix inferior)` module provides equivalent functions for inferior packages: `inferior-package-name` and `inferior-package-version`. Here's a patch that demonstrates which part needs to be changed:

```
diff --git a/gnu/system.scm b/gnu/system.scm
index a5a8f40d6..3c3fe94ad 100644
--- a/gnu/system.scm
+++ b/gnu/system.scm
@@ -21,6 +21,7 @@
 ;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.

 (define-module (gnu system)
+  #:use-module (guix inferior)
   #:use-module (guix store)
   #:use-module (guix monads)
   #:use-module (guix gexp)
@@ -906,8 +907,8 @@ listed in OS.  The C library expects to find it under
 (define (kernel->boot-label kernel)
   "Return a label for the bootloader menu entry that boots KERNEL."
   (string-append "GNU with "
-                 (string-titlecase (package-name kernel)) " "
-                 (package-version kernel)
+                 (string-titlecase (inferior-package-name kernel)) " "
+                 (inferior-package-version kernel)
                  " (beta)"))

 (define (store-file-system file-systems)
```

I tested this and it made inferior-packages able to be used as a kernel - I'm running that kernel on my system now, I wrote a guide on how to do that if anyone's interested, which includes an example of how to add it to your system configuration: http://miha.info/2018-Dec-09/how-to-add-a-modified-kernel-built-using-a-previous-guix-commit-to-your-system-configuration/

I assume the solution is to modify the `kernel->boot-label` function to check if the package passed to it is an inferior package, and use the compatible functions to get the name and version of the package depending on if it's inferior or not, however I don't know scheme/guile well enough to do this, and I don't know if this is the correct solution to do, so it would be great if someone could else could create a patch that fixes this.